/* (C)1999 LGB */

#ifndef _LOCAL_FILENAME_H
#define _LOCAL_FILENAME_H

extern char path[];

struct drive_acl_struct {
  unsigned int  write  : 1 ;  /* drive ACL : write access enabled       */
  unsigned int  delete : 1 ;  /* drive ACL : delete access enabled      */
  unsigned int  move   : 1 ;  /* drive ACL : move/rename access enabled */
  unsigned int  chmod  : 1 ;  /* drive ACL : chmod access enabled       */
  unsigned int  create : 1 ;  /* drive ACL : create access enabled      */
};

struct drive_struct {
  int  valid;  /* valid drive ? */
  char *root;  /* drive's root directory */
  char *dir;   /* drive's actual directory */
  struct drive_acl_struct acl;
};

#define WRITE_ACCESS   1
#define READ_ACCESS    2
#define STAT_ACCESS    4
#define DELETE_ACCESS  8
#define MOVE_ACCESS   16
#define CREATE_ACCESS 32
#define DIR_ACCESS    64
#define CHMOD_ACCESS 128

#define WR_ACCESS WRITE_ACCESS|DELETE_ACCESS|MOVE_ACCESS|CREATE_ACCESS|CHMOD_ACCESS
#define RD_ACCESS READ_ACCESS|DIR_ACCESS|STAT_ACCESS

int path_d2u ( char * , int );
int get_dosdir ( int , char * );
int set_dosdir ( char * );
void set_dosdir_unix ( int , char * );
void dosdrive_init ( void );
int dosdrive_add ( int , char * );
int dosdrive_set ( int );
int dosdrive_get ( void );
int dosdrive_getnumof ( void );
int dosdrive_getnumoffdds ( void );
struct drive_acl_struct *dosdrive_getacl ( int );
int dir_isdosroot ( int , char * );
char *dosdrive_getroot ( int );

#endif
