/* INT 1A implementation for DOSRUN
   (C)1999 LGB, Gabor Lenart, lgb@vlug.vein.hu
   GPL software                                              */

#include "config_dosrun.h"
#ifdef CONFIG_INT1A   /* a BIG ifdef block */

#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>
#include "dosrun.h"

extern word oldcs,oldip;


#define TO_BCD(x) (((x/10)<<4)+x%10)


int int1a_emu ( void )
{
  switch (AH) {
    /* get time counter [18.2 times per second] */
    case 0x00 : {
                  time_t t=time(NULL);
		  struct tm *tim=localtime(&t);
		  struct timeval tv;
		  struct timezone tz;
		  unsigned int i;
		  gettimeofday(&tv,&tz);
		  i=(unsigned int)((double)tim->tm_hour*65520.0+(double)tim->tm_min*1092.0+(double)tim->tm_sec*18.2+(double)tv.tv_usec/54945.049);
                  AL=0; /* well :) don't run dosemu through days :) */
                  CX=i>>16;
		  DX=i&0xFFFF;
		  if (stddebug) fprintf(stddebug,"INT1A: read counter i=%d\n",i);
                  return 1;
		}
    /* set time counter */
    case 0x01 : return 1; /* just ignore */
    /* read realtime clock */
    case 0x02 : {
                  time_t t=time(NULL);
		  struct tm *tim=localtime(&t);
                  CLC; /* battery charged */
		  CH=TO_BCD(tim->tm_hour);
		  CL=TO_BCD(tim->tm_min);
		  DH=TO_BCD(tim->tm_sec);
		  DL=1; /* enable daylight saving ? */
		  return 1;
		}
    /* set realtime clock */
    case 0x03 : return 1; /* just ignore */
    /* read date of realtime clock */
    case 0x04 : {
                  time_t t=time(NULL);
		  struct tm *tim=localtime(&t);
                  CLC; /* battery charged */
		  CH=TO_BCD(tim->tm_year/100+19);
		  CL=TO_BCD(tim->tm_year%100);
		  DH=TO_BCD(tim->tm_mon+1);
		  DL=TO_BCD(tim->tm_mday);
		  return 1;
		}
    /* set date of realtime clock */
    case 0x05 : return 1; /* just ignore */    
  }
#ifdef CONFIG_DEBUG_UNIMPLEMENTED_FUNC
  if (stddebug) fprintf(stddebug,"INT1A: unimplemented function (CS:IP=%04X:%04X) AX=%04Xh.\n",oldcs,oldip,AX);
#endif
  return 1;
}

#endif
