static __inline__ void pushw ( word w )
{
  SP-=2;
  *DOS_PW(SS,SP)=w;
}

static __inline__ word popw ( void )
{
  SP+=2;
  return *DOS_PW(SS,SP-2);
}


void dump_address ( int seg , int ofs , int force )
{
  FILE *f;
  byte *p;
  int a;
  if (stddebug&&!force) f=stddebug; else f=stderr;
  fprintf(f,"CS:EIP=%04X:%08X DS=%04X ES=%04X EBP=%08X              FS=%04X\n",seg,ofs,DS,ES,EBP,FS);
  fprintf(f,"SS:ESP=%04X:%08X EFLAGS=%08X ESI=%08X EDI=%08X GS=%04X\n",SS,ESP,EFLAGS,ESI,EDI,GS);
  fprintf(f,"EAX=%08X         EBX=%08X    ECX=%08X EDX=%08X\n",EAX,EBX,ECX,EDX);
  p=(byte*)(seg<<4)+ofs;
  fprintf(f,"Code:");
  for (a=0;a<16;a++) fprintf(f," %02X",*(p++));
  fprintf(f,"\n\n");
}


__inline__ void dump ( int force )
{
  dump_address(CS,IP,force);
}


void dosrun_fatal ( char *s )
{
  screen_uninit();
  fprintf(stderr,"DOSRUN fatal error: %s\n",s);
  perror("errno: ");
  exit(1);
}


__inline__ void *dosrun_malloc ( int size )
{
  void *p=malloc(size);
  if (!p) dosrun_fatal("malloc");
  return p;
}


__inline__ void *dosrun_realloc ( void *p , int size )
{
  void *q=realloc(p,size);
  if (!q) dosrun_fatal("realloc");
  return q;
}


/* __inline__ void dosrun_free ( void *p )
{
  free(p);
} */


__inline__ char *dosrun_strdup ( char *s )
{
  char *p=strdup(s);
  if (!p) dosrun_fatal("strdup");
  return p;
}
