static __inline__ int emu ( void )
{
  int ret,intno;
  ret=dosrun_vm86(VM86_ENTER);
  switch (VM86_TYPE(ret)) {
    case VM86_SIGNAL  : if (stddebug) fprintf(stddebug,"VM86: VM86_SIGNAL return value=%d\n",VM86_ARG(ret));
                        dump(1);
                        return 0;
    case VM86_UNKNOWN : return inst_emu();
    case VM86_INTx    : intno=VM86_ARG(ret);
                        if (stddebug) fprintf(stddebug,"Int REQUEST %02Xh (AX=%04Xh) at %04X:%04X\n",intno,AX,CS,IP-2);
#ifdef CONFIG_XMS			  
                        if (DOS_PA(CS,IP)==DOS_PA(XMS_PROC_SEG,XMS_PROC_OFS)+2) return xms_emu();
#endif
                        if (CS!=EMU_INT_SEG) {  /* not our emulated area */
                          pushw(FLAGS);  /* simulate interrupt */
                          pushw(CS);
                          pushw(IP);
                          if (!oldcs&&!oldip) oldcs=CS,oldip=IP-2;
                          IP=*(word*)(intno<<2);
                          CS=*(word*)((intno<<2)+2);
                          if (stddebug) fprintf(stddebug,"Int REDIRECT %02Xh (AH=%02Xh) at %04X:%04X to %04X:%04X\n",intno,AH,oldcs,oldip,CS,IP);
                          return 1;
                        }
                        /* Hit our emulation area */
                        intno=(signed int)IP-2-EMU_INT_OFS;
                        if (intno<0||intno>0xFF) {
                          if (stderr) fprintf(stddebug,"Int %02Xh !! received in emulated area at %04X:%04X !!\n",VM86_ARG(ret),CS,IP-2);
                          return 1;
                        }
                        if (stddebug) fprintf(stddebug,"Int PROCESS %02Xh (AH=%02Xh) at %04X:%04X\n",intno,AH,CS,IP-2);
                        ret=0;
                        switch (intno) {
                          case 0x10 : ret=int10_emu();
                                      break;
                          case 0x11 : {
                                        int fdds=dosdrive_getnumoffdds();
                                        int r;
                                        if (fdds) r=1; else r=0;
                                        r|=2+32; /* FPU present, 80*25 color video card */
                                        r|=fdds<<6;  /* number of fdds in system */
                                        AX=r;
                                        ret=1;
                                        break;
                                      }
                          case 0x12 : AX=CONFIG_DOSMEM_SIZE;    /* memory below 1M */
                                      ret=1;
                                      break;
#ifdef CONFIG_INT15
                          case 0x15 : ret=int15_emu();
                                      break;
#endif
#ifdef CONFIG_INT16
                          case 0x16 : ret=int16_emu();
                                      break;
#endif
                          case 0x19 : fprintf(stderr,"Exit on int 19h (boot)\n");
                                      ret=0;
                                      break;
#ifdef CONFIG_INT1A
                          case 0x1A : ret=int1a_emu();
                                      break;
#endif
                          case 0x20 : if (stddebug) fprintf(stddebug,"Exit on int 20h\n");
                                      ret=0;
                                      break;
                          case 0x21 : ret=int21_emu();
                                      break;
                          case 0x29 : ret=1;
                                      putchar(AL);
                                      fflush(stdout);
                                      break;
#ifdef CONFIG_COMMAND
                          case 0x2e : ret=int2e_emu();
                                      break;
#endif
#ifdef CONFIG_INT2F
                          case 0x2f : ret=int2f_emu();
                                      break;
#endif
#ifdef CONFIG_INT33
                          case 0x33 : ret=int33_emu();
                                      break;
#endif
                          default   :
#ifdef CONFIG_DEBUG_UNIMPLEMENTED_INT
                                      if (stddebug) {
                                        fprintf(stddebug,"INT: unimplemented interrupt int %02Xh\n",intno);
                                        dump_address(oldcs,oldip,0);
                                      }
#endif
                                      ret=1;
                                      break;

                        } /* switch */
                      if (ret) {
                        if (stddebug) fprintf(stddebug,"interrupt processed.\n");
                        oldcs=0;
                        oldip=0;
                        IP=popw();
                        CS=popw();
                        SP+=2; /* drop FLAGS from stack */
                        return ret;
                      } else return 0;
    case VM86_STI       : if (stddebug) {
                            fprintf(stddebug,"VM86: VM86_STI return value\n");
                            dump(1);
			  }
                          return 1;
    case VM86_TRAP      : fprintf(stderr,"VM86: VM86_TRAP return value\n");
                          dump(1);
			  return 0;
    case VM86_PICRETURN : fprintf(stderr,"VM86: VM86_PICRETURN return value\n");
                          dump(1);
			  return 0;
  } /* switch */
  fprintf(stderr,"VM86: !! unknown VM86 return value !!\n");
  dump(1);
  return 0;
}
