extern int dos_version;


#ifdef CONFIG_FULL_SCREEN
static int optf_fullscr ( int n , int enable , char **p )
{
  config.fullscreen=enable;
  return 0;
}


#ifdef CONFIG_AUTO_FULL_SCREEN
static int optf_afullscr ( int n , int enable , char **p )
{
	if (enable) {
    config.fullscreen=0;
    config.autofullscreen=1;
	} else {
		config.autofullscreen=0;
	}
  return 0;
}
#endif
#endif


static int optf_env ( int n , int enable , char **p )
{
  while (n--) {
    char *s=dosrun_strdup(p[n]);
    char *s2=strchr(s,'=');
    if (!s2) {
      fprintf(stderr,"Envirnoment string must be present in `string=value' format.\n");
      return -1;
    }
    *(s2++)='\0';
    env=env_pass_string(env,s,s2);
    free(s);
  }
  return 0;
}


static int optf_debug ( int n , int enable , char **p )
{
  if (!strcmp(*p,"stderr")) stddebug=stderr;
    else if (!strcmp(*p,"stdout")) stddebug=stdout;
      else if ((stddebug=fopen(*p,"w"))==NULL) {
        fprintf(stderr,"Cannot create file %s for debug information.\n",*p);
        return -1;
      }
  return 0;
}


static int optf_dosver ( int n , int enable , char **p )
{
  char *s=dosrun_strdup(p[0]);
  char *s2=strchr(s,'.');
  if (!s2) {
    fprintf(stderr,"DOS version number must be in `n.mm' format\n");
    return -1;
  }
  *(s2++)='\0';
  dos_version=(atoi(s2)<<8)+atoi(s);
  free(s);
  return 0;
}


static int optf_drive ( int n , int enable , char **p )
{
  int drive;
  if (**p>='A'&&**p<='Z') drive=**p-'A';
    else if (**p>='a'&&**p<='z') drive=**p-'a'; else {
      fprintf(stderr,"Unknown drive id %c\n",**p);
      return -1;
    }
  if (dosdrive_add(drive,p[1])) {
    fprintf(stderr,"Cannot assign drive %c: (illegal drive letter or assigned path).\n",drive+'A');
    return -1;
  }
  if (n==3) {
    char *q=p[2];
    int enable;
    struct drive_acl_struct *acl=dosdrive_getacl(drive);
    while (*q) {
      if (q[1]=='-') enable=0;
        else if (q[1]=='+') enable=1; else {
          fprintf(stderr,"Unknown ACL modifier tag (must be `+' or `-').\n");
    	  return -1;
        }
      switch (*q) {
        case 'w' : acl->write=enable; break;
        case 'd' : acl->delete=enable; break;
        case 'm' : acl->move=enable; break;
        case 'h' : acl->chmod=enable; break;
        case 'c' : acl->create=enable; break;
        default  : fprintf(stderr,"Unknown ACL tag (must be `w',`d',`m',`h' or `c').\n");
                   return -1;
      } /* switch */
      q+=2;
    } /* while */
  }
  return 0;
}


#ifdef CONFIG_XMS
static int optf_xms ( int n , int enable , char **p )
{
  if (!enable) xms_params(0,0,0); else {
    int o_xms_size=atoi(p[0])<<10;
    int o_xms_handles=atoi(p[1]);
    int o_xms_hmamin=atoi(p[2]);
    if (o_xms_size<0x10000) {
      fprintf(stderr,"XMS size must be at least 64K.\n");
      return -1;
    }
    if (o_xms_handles<16) {
      fprintf(stderr,"XMS handles must be at least 16.\n");
      return -1;
    }
    if (o_xms_hmamin<1024||o_xms_hmamin>64000) {
      fprintf(stderr,"XMS hmamin must be between 1024 and 64000 bytes.\n");
      return -1;
    }
    xms_params(o_xms_size,o_xms_handles,o_xms_hmamin);
  } /* else */
  return 0;
}
#endif


static int optf_version ( int n , int enable , char **p )
{
  fprintf(stderr,"DOSRUN v%s\n",DOSRUN_VERSION);
  return -1;
}
