#include "config_dosrun.h"
#ifdef CONFIG_FULL_SCREEN  /* a BIG ifdef block */
#include <stdio.h>
#include <ncurses.h>
#include "dosrun.h"

/* Looks ugly, but gcc seems to be good at optimizing large switch
 * statments like this with generating jumping tables or so */
__inline__ chtype screen_translate_char ( byte c )
{
  switch (c) {
    case   0 :
    case   1 :
    case   2 :
    case   3 :
    case   4 :
    case   5 :
    case   6 :
    case   7 :
    case   8 :
    case   9 :
    case  10 :
    case  11 :
    case  12 :
    case  13 :
    case  14 :
    case  15 : return ' ';
    case  16 : return ACS_RARROW;
    case  17 : return ACS_LARROW;
    case  18 : return ' ';
    case  19 : return '!';
    case  20 :
    case  21 :
    case  22 :
    case  23 : return ' ';
    case  24 : return ACS_UARROW;
    case  25 : return ACS_DARROW;
    case  26 : return ACS_RARROW;
    case  27 : return ACS_LARROW;
    case  28 :
    case  29 : return ' ';
    case  30 : return ACS_UARROW;
    case  31 : return ACS_DARROW;

		case 129 : return '';
		case 130 : return '';
		case 140 :
		case 141 : return '';
		case 143 : return '';
		case 144 : return '';
		case 147 : return '';
		case 148 : return '';
		case 162 :
		case 149 : return '';
		case 150 : return '';
		case 151 :
		case 163 : return '';
		case 153 : return '';
		case 154 : return '';

    case 156 : return ACS_STERLING;

    case 176 : return ACS_BOARD;
    case 177 : return ACS_BOARD;
    case 178 : return ACS_CKBOARD;
    case 179 : return ACS_VLINE;
    case 180 : return ACS_RTEE;
    case 181 : return ACS_RTEE;
    case 182 : return ACS_RTEE;
    case 183 : return ACS_URCORNER;
    case 184 : return ACS_URCORNER;
    case 185 : return ACS_RTEE;
    case 186 : return ACS_VLINE;
    case 187 : return ACS_URCORNER;
    case 188 : return ACS_LRCORNER;
    case 189 : return ACS_LRCORNER;
    case 190 : return ACS_LRCORNER;
    case 191 : return ACS_URCORNER;
    case 192 : return ACS_LLCORNER;
    case 193 : return ACS_BTEE;
    case 194 : return ACS_TTEE;
    case 195 : return ACS_LTEE;
    case 196 : return ACS_HLINE;
    case 197 : return ACS_PLUS;
    case 198 : return ACS_LTEE;
    case 199 : return ACS_LTEE;
    case 200 : return ACS_LLCORNER;
    case 201 : return ACS_ULCORNER;
    case 202 : return ACS_BTEE;
    case 203 : return ACS_TTEE;
    case 204 : return ACS_LTEE;
    case 205 : return ACS_HLINE;
    case 206 : return ACS_PLUS;
    case 207 : return ACS_BTEE;
    case 208 : return ACS_BTEE;
    case 209 : return ACS_TTEE;
    case 210 : return ACS_TTEE;
    case 211 : return ACS_LLCORNER;
    case 212 : return ACS_LLCORNER;
    case 213 : return ACS_ULCORNER;
    case 214 : return ACS_ULCORNER;
    case 215 : return ACS_PLUS;
    case 216 : return ACS_PLUS;
    case 217 : return ACS_LRCORNER;
    case 218 : return ACS_ULCORNER;
    case 219 : return ACS_BLOCK;

    case 227 : return ACS_PI;

    case 241 : return ACS_PLMINUS;
    case 242 : return ACS_GEQUAL;
    case 243 : return ACS_LEQUAL;
    case 248 : return ACS_DEGREE;

    default  : return c;
  }
}


void keyboard_translate_char ( int c , byte *c1 , byte *c2 )
{
	if (stddebug) fprintf(stddebug,"KEYBOARD: c=%d (%c)\n",c,c>32&&c<128?c:'?');
	switch (c) {
		case KEY_DOWN      : *c1=0; *c2=0x50; break;
		case KEY_UP        : *c1=0; *c2=0x48; break;
		case KEY_RIGHT     : *c1=0; *c2=0x4D; break;
		case KEY_LEFT      : *c1=0; *c2=0x4B; break;
		case KEY_NPAGE     : *c1=0; *c2=0x51; break;
		case KEY_PPAGE     : *c1=0; *c2=0x49; break;
		case KEY_F0+1      : *c1=0; *c2=0x3B; break;
		case KEY_F0+2      : *c1=0; *c2=0x3C; break;
		case KEY_F0+3      : *c1=0; *c2=0x3D; break;
		case KEY_F0+4      : *c1=0; *c2=0x3E; break;
    case KEY_F0+5      : *c1=0; *c2=0x3F; break;
		case KEY_F0+6      : *c1=0; *c2=0x40; break;
		case KEY_F0+7      : *c1=0; *c2=0x41; break;
		case KEY_F0+8      : *c1=0; *c2=0x42; break;
		case KEY_F0+9      : *c1=0; *c2=0x43; break;
		case KEY_F0+10     : *c1=0; *c2=0x44; break;
		case 9             : *c1=9; *c2=0xF; break;      /* TAB */
		case KEY_BACKSPACE : *c1=8; *c2=0xE; break;
		case 10            : *c1=0xD; *c2=0x1C; break;  /* ENTER */
    default            : *c1=c; *c2=c;    return;
	}
}


#endif

